uniform float inverseSize;
uniform sampler2D sourceTexture;

const int radius=1;
const int numSamples=(2*radius+1)*(2*radius+1);
const float inv_numSamples = 1/float(numSamples);

void main()
{
	vec4 colorFinal=0;
	vec2 right	=vec2(0,inverseSize);
	vec2 down	=vec2(inverseSize,0);	

	for (int i=-radius;i<=radius;i++){
		for (int j=-radius;j<=radius;j++){
			colorFinal+=texture2D(sourceTexture, gl_TexCoord[0] + i*right + j*down);
		}
	}
		
	colorFinal=colorFinal * inv_numSamples;

	gl_FragColor=colorFinal;
}
