uniform vec3 light_position;//world space light position
uniform vec4 light_color; //light color and intensity

///***These commented lines are for diffraction-mapping, when there is time***//
//uniform sampler2D diffractionMap;
//uniform vec3 lightSource;//light source 2 meters behind grating

////These 3 params specify the position and orientation of the grating.
//uniform vec3 gratingPosition;
//uniform vec3 gratingXAxis; //x axis
//uniform vec3 gratingYAxis; //y axis
//uniform vec2 gratingBoundsX;//extent of grating along x and y axes (x1,y1,x2,y2)
//uniform vec2 gratingBoundsY;//extent of grating along x and y axes (x1,y1,x2,y2)

varying vec3 surface_normal;//normal vector 
varying vec3 surface_position;//position of the vertex


void main()
	{
	vec3 distanceVector = light_position - surface_position;
	float diffuseLight = max(0.0,dot(normalize(distanceVector), surface_normal)) / length(distanceVector);
	gl_FragColor=diffuseLight*light_color;
//	gl_FragColor=texture2D(sourceTexture, gl_TexCoord[0].xy);
	}
