const float PI = 3.141593;

float rect(float x);
float sinc(float x);
float triangleFunction(float x);
float kdelta(float x);

//generic uniforms to control grating parameters
uniform vec4 gratingParameters;

//2D Square Aperture
float wdf_2DAperture(float x,float y,float u,float v, float aperture){

	float outputX= 2.0*aperture* triangleFunction(x*2.0/aperture)*sinc( (2.0*aperture-4.0*abs(x))*u );
	float outputY= 2.0*aperture* triangleFunction(y*2.0/aperture)*sinc( (2.0*aperture-4.0*abs(y))*v );

	return outputY*outputX;
}

float wdf_wrapper(float x,float y,float u,float v, float lambda){
//the meaning of each component of gratingParameters is defined here:

//Square Aperture:
	//gratingParameters.x = aperture width
	return wdf_2DAperture(x,y,u,v,gratingParameters.x);
}
