const float PI = 3.141593;

float rect(float x);
float sinc(float x);
float triangleFunction(float x);
float kdelta(float x);

//generic uniforms to control grating parameters
uniform vec4 gratingParameters;


float binaryGrating2(float x, float u, float pitch, float dutyCycle){
	float result = 0.0;
	float uPitch = u * pitch;
	if (kdelta(uPitch - round(uPitch))>0.0){
		for (int p = -5; p<=5; p++){
			result += 	sinc(dutyCycle * 0.5 * (uPitch*2.0 + float(p))) * 
						sinc(dutyCycle * 0.5 * (uPitch*2.0 - float(p))) * 
						cos(2.0 * PI * float(p) * x / pitch);
		}
		return (dutyCycle * dutyCycle) * result; 
	}
	else
		return 0.0;
}

float wdf_2DBinaryGrating(float x,float y,float u,float v,float pitch, float dutyCycle){
	return binaryGrating2(x,u,pitch,dutyCycle) * binaryGrating2(y,v,pitch,dutyCycle);
}

float wdf_wrapper(float x,float y,float u,float v, float lambda){
//the meaning of each component of gratingParameters is defined here:

//Binary Grating:
	//gratingParameters.x => grating pitch
	//gratingParameters.y => grating duty cycle
	return	binaryGrating(x,u,gratingParameters.x,gratingParameters.y) *
			binaryGrating(y,v,gratingParameters.x,gratingParameters.y);
}
