const float PI = 3.141593;

float rect(float x);
float sinc(float x);
float triangleFunction(float x);
float kdelta(float x);

//generic uniforms to control grating parameters
uniform vec4 gratingParameters;

float wdf_QuadraticPhaseMask(float x, float u, float focus, float aperture, float lambda){
//	return kdelta(theta + (2.0*PI*x/focal_length));

	return (2*aperture - 4*abs(x))*rect(x/aperture) * sinc( (2*aperture - 4*abs(x)) * (u+ x/lambda*focus));

}

float wdf_wrapper(float x,float y,float u,float v, float lambda){
//the meaning of each component of gratingParameters is defined here:

//Quadratic phase mask.
	//gratingParameters.x => Focal Length
	//gratingParameters.y => Aperture size	
	return 	wdf_QuadraticPhaseMask(y, v, gratingParameters.x, gratingParameters.y, lambda) *
			wdf_QuadraticPhaseMask(x, u, gratingParameters.x, gratingParameters.y, lambda) ;

//	return 	kdelta(u*lambda + 2*PI*x/gratingParameters.x) * 
//			kdelta(v*lambda + 2*PI*y/gratingParameters.x);

}
