const float PI = 3.141593;

float rect(float x);
float sinc(float x);
float triangleFunction(float x);
float kdelta(float x);

//generic uniforms to control grating parameters
uniform vec4 gratingParameters;

float dbl_slit(float x, float u, float a, float A){
	return 	rect((x-a)/A) * (2.0 * A - 4.0 * abs(x - a)) * sinc((2.0*A - 4.0*abs(x - a))*u) + 
			rect((x+a)/A) * (2.0 * A - 4.0 * abs(x + a)) * sinc((2.0*A - 4.0*abs(x + a))*u) + 
			2.0*rect(x/A) * (2.0 * A - 4.0 * abs(x)) * sinc((2.0*A - 4.0*abs(x))*u)*cos(2.0*PI*u*2.0*a);
}

float wdf_wrapper(float x,float y,float u,float v, float lambda){
//the meaning of each component of gratingParameters is defined here:

//Young's double slit
	//gratingParameters.x => a (separation/2)
	//gratingParameters.y => A (Aperture)
	float a = gratingParameters.x;
	float A = gratingParameters.y;
	return dbl_slit(x,u,a,A);
}
