#include"functionrender.h"
#include"vbo.h"

void enableOrthoView(float width, float height)
	{
	glPushAttrib(GL_VIEWPORT_BIT); 
	glViewport(0, 0, width, height);   
	
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();
	
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	gluOrtho2D(0.0, width, 0.0, height);		
	}

void disableOrthoView()
	{
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glPopAttrib();
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	}

void renderQuad(float width, float height)
	{
    glClearColor(1, 1, 1, 1);
    glClear(GL_COLOR_BUFFER_BIT);

    glBegin(GL_QUADS);			//render a quad to the dest fbo
		{
		glTexCoord2f(0,0);	glVertex2f(0,0);
		glTexCoord2f(0,1);	glVertex2f(0,height);
		glTexCoord2f(1,1);	glVertex2f(width,height);
		glTexCoord2f(1,0);	glVertex2f(width,0);
		}
    glEnd();    
	}

bool renderToTexture(ProgramGLSL * renderShader, RenderTarget* fbo, const int SIZE)
    {    
// render to the fbo texture first
    fbo->enable();
    
//setup the view for rendering to the fbo
	enableOrthoView(SIZE,SIZE);

//render to FBO texture
    renderShader->bind();
	renderQuad(SIZE,SIZE);

    fbo->disable();  
    disableOrthoView();    
	renderShader->unbind();
	
    return false;
    }
  
bool applyShader(ProgramGLSL * renderShader, Texture* src, RenderTarget* dest, const int SIZE)
	{
   
// render to the fbo texture first
    dest->enable();
//setup the view for rendering to the fbo
	enableOrthoView(SIZE,SIZE);
    
//render to FBO texture
    glActiveTexture(GL_TEXTURE0);//set active texture unit as 0
    
    src->enable(true);//enable the source texture

    renderShader->bind();		//enable curvature shader

    renderShader->setAllUniforms();
	
	renderQuad(SIZE,SIZE);
           
    dest->disable();
    src->disable(true);

	disableOrthoView();    
    renderShader->unbind();

    return false;			
	}
	
bool applyShader(ProgramGLSL * renderShader, Texture* src1, Texture* src2, RenderTarget* dest, int SIZE)
	{
   
// render to the fbo texture first
    dest->enable();
//setup the view for rendering to the fbo
	enableOrthoView(SIZE,SIZE);
    
//render to FBO texture
    glActiveTexture(GL_TEXTURE0);//set active texture unit as 0    
    src1->enable(true);//enable the source texture
    
    glActiveTexture(GL_TEXTURE1);//set active texture unit as 1
    src2->enable(true);//enable the other source texture

    renderShader->bind();		//enable the shader
	
	renderShader->setAllUniforms();
	
	renderQuad(SIZE,SIZE);

    dest->disable();
    src1->disable(true);
    src2->disable(true);
    
	disableOrthoView();    
    renderShader->unbind();

    return false;			
	}
	
bool applyShader(ProgramGLSL * renderShader, RenderTarget* dest, int SIZE) //Zero textures
	{   
// render to the fbo texture first
    dest->enable();
//setup the view for rendering to the fbo
	enableOrthoView(SIZE,SIZE);
    
    renderShader->bind();		//enable the shader
    
   	renderShader->setAllUniforms();//bind any uniforms we need
	
	renderQuad(SIZE,SIZE);
           
    dest->disable();
    
	disableOrthoView();    
    renderShader->unbind();

    return false;			
	}

