/*
 * OutputBuffer.h
 *
 *  Created on: 05-Jul-2009
 *      Author: sri
 */

#ifndef IMAGEBUFFER_H_
#define IMAGEBUFFER_H_

#include <cv.h>
#include <highgui.h>
#include <string>
#include <cstring>//for memcpy
#include <ImfRgbaFile.h>

using std::string;
using Imf::Rgba;

//NOTE: This class is purely for visualisation purpose. Feel free to ignore it.
class ImageBuffer{
protected:
        IplImage * canvas;
        int numChannels;
        int bytesPerChannel;// 1 for int, 4 for float

		void saveFileEXR (const char fileName[]);
        void loadFileEXR (const char fileName[]);
        void readRgbaEXR (const char fname[], Rgba * &pixels, int &width, int &height);

public:
        ImageBuffer();
        ~ImageBuffer();
        void init(int width, int height, int channels, int bytesPerChannel=1);
        
        void save(string fname);
        
        void load(string fname);
        
        bool isValid();
        
        void copyFromBuffer(void * buffer);
        
        void show(string windowName);
        void * getBuffer();
//        void showAnimated(int waitMS);

		int getWidth();
		int getHeight();
		int getNumChannels();
		int getBytesPerChannel();

        //returns a reference to the pixel
        unsigned char& pixeli(int row, int col, int channel);
        float& pixelf(int row, int col, int channel);
};

#endif /* OUTPUTBUFFER_H_ */
