//contains lots of functions moved from main.cpp

#include <renderer.h>
#include <grating.h>

//Some Constants
const int SCREEN_SIZE			= 1024;
const int RANDOM_TEXTURE_SIZE 	= 512;
//const float BUCKET_SIZE 		= 16.0f;	//Bucket size denotes how many sample steps we take in one bucket.
//const float SAMPLE_STEP 	 	= 0.002f;//Sample step denotes distance between 2 samples on grating
//const float GRATING_SIZE		= 1.0f;		//size of the grating

/////SHADER UNIFORMS/////////
enum {	WLF_BUCKET_START_UNIFORM=0, 
		WLF_BUCKET_SIZE_UNIFORM, 
		WLF_SAMPLE_STEP_UNIFORM, 
		WLF_RAND_TEXTURE_UNIFORM, 
		WLF_FILTER_TEXTURE_UNIFORM,
		WLF_INTENISTY_NORM_UNIFORM, 
		WLF_LIGHTSOURCE_UNIFORM,
		WLF_LIGHTCOLOR_UNIFORM,
		WLF_GRATING_POSITION_UNIFORM,
		WLF_GRATING_XAXIS_UNIFORM,
		WLF_GRATING_YAXIS_UNIFORM,
		WLF_GRATING_PARAM_UNIFORM,
		WLF_GRATING_SIZE_UNIFORM,
		WLF_RANDOM_SIZE_UNIFORM};

enum {	CLEAR_COLOR_UNIFORM=0};

enum {	ACCUMULATOR_TEXTURE1_UNIFORM=0, 
		ACCUMULATOR_TEXTURE2_UNIFORM,
		ACCUMULATOR_COEFFS_UNIFORM,
		ACCUMULATOR_FLAGS_UNIFORM};

enum {	FINAL_DRAW_TEXTURE_UNIFORM=0};

enum {	DIFFUSE_LIGHT_SOURCE=0,
		DIFFUSE_LIGHT_COLOR};

//to save a 4 channel texture as a file:
void saveTextureToFile(Texture* tex, string fname, int size);

//to create a random 2d texture for storing random numbers
void setupRandomTexture(Texture*& tex, int width, int height);

//to create light filter texture
void loadTextureFromFile(Texture*& tex, string fname);

//big function to do diffraction stuff :P
Texture* computeDiffractionTexture(Renderer& renderObject, string fname, const grating& g);

//get uniform values, set them etc:
void initializeShaderUniforms(Renderer& renderObject);

inline float degreesToRadians(const float degree)
	{
	return degree*(3.14159265/180.0);
	}
