#ifndef DRAW_SCENE_H
#define DRAW_SCENE_H

#include <Eigen/Core>
#include <Eigen/Geometry>
using Eigen::Vector3f;

//all the mesh creation functionality is in drawScene.cpp/h
//call drawScene to draw the scene, the rest of the functions should draw basic objects/elements

struct vertexStruct
	{
public:	
	float x,y,z;//position
	float nx,ny,nz;//normal
	float tx,ty;//tex-coords
	
public:	
	vertexStruct(float x, float	y, float z, float nx, float ny, float nz, float tx, float ty)
		{
		set(x, y, z, nx, ny, nz, tx, ty);
		}
		
	vertexStruct()
		{}
		
	void set(float x, float y, float z, float nx, float ny, float nz, float tx, float ty)
		{
		this->x=x; 	this->y=y; 	this->z=z;
		this->nx=nx;this->ny=ny;this->nz=nz;
		this->tx=tx;this->ty=ty;
		}
		
	void setPos(float x, float y, float z)
		{
		this->x=x; 	this->y=y; 	this->z=z;
		}
	
	void setNormals(float nx, float ny, float nz)
		{
		this->nx=nx; 	this->ny=ny; 	this->nz=nz;
		}	
		
	void setTexcoords(float tx, float ty)
		{
		this->tx=tx; 	this->ty=ty;
		}		
	};

void drawQuad(float size);
//void drawCornellRoom();
void createScene(VertexBuffer* vbo);
void createPlane(const Vector3f& center, const Vector3f& normal, const Vector3f& up, float size, vector<vertexStruct>& vertices, vector<GLuint>& indices);
//void drawMesh();

#endif
