#ifndef __RENDERER__
#define __RENDERER__

#include <iostream>
#include <cmath>
#include <cstdlib>
#include <SDL.h>
#include <GL/glew.h>
#include <cstring>

#include "sdlutil.h"
#include "camera.h"
#include "shader.h"
#include "program.h"
#include "rendertarget.h"
#include "functionrender.h"
#include "vbo.h"
#include "texBO.h"
#include "vectorMath.h"
#include "tonemap.h"

#include<map>

//////////////////////
//shaders
enum ShaderEnum
	{
	WLF_SHADER=0, 
	ACCUMULATE_SHADER,
	FINAL_DRAW_SHADER,
	CLEAR_SHADER,
	TONE_MAP_SHADER,
	DIFFUSE_SHADER
	};
//rendertargets
enum RenderTargetEnum
	{
	OUTPUT_BUFFER=0,
	ACCUMULATOR1,
	ACCUMULATOR2
	};
//textures
enum TextureEnum
	{
	RANDOM_TEXTURE=0,
	FILTER_TEXTURE
	};

enum VBOEnum
	{
	SCENE_VBO=0
	};

class Renderer
    {
    public:
    map<ShaderEnum, ProgramGLSL*> Shaders;
    map<RenderTargetEnum, RenderTarget*> RenderTargets;
    map<TextureEnum, Texture*>	Textures;
    map<VBOEnum, VertexBuffer*> VertexBuffers;
    ~Renderer();
    bool validateShaders();
    };

#endif
