#ifndef __TEX_BO__
#define __TEX_BO__

#include <GL/glew.h>
#include <iostream>
using namespace std;

/*
usage

texBO * texBuf=new texBO(512, GL_STATIC_DRAW, data);
texBuf->bind();
*/
class TextureBuffer
	{
	
	public:
	//assumes a 4 element texel
	//for now, it is assumed to be a floating point format, could be different later on.
	TextureBuffer(uint32_t elements, GLenum usage=GL_STATIC_DRAW, const void* data=NULL);
	~TextureBuffer();
	
	void* map();
	bool unmap();
	
	void bind();
	void unbind();
	
	inline GLuint width()
		{
		return mWidth;
		}
	
	private:
	GLuint mTexture;
	GLuint mWidth;
	GLuint mTextureBuffer;
	};
	
#endif 
