//Sriram Kashyap: 
//This is a very simple VBO class. 

#ifndef VBO_H
#define VBO_H
#include <GL/glew.h>

enum eflags{F_NORMAL=0, F_COLOR=1, F_EDGE=2, F_INDEX=3, F_VERTEX=4, F_TEXTURE=5};

class VertexBuffer{
protected:
	GLenum dataFormat;//GL_QUAD, GL_TRIANGLE etc...
	GLuint vboId1, vboId2;
	int numberOfVertices;
	int numberOfIndices;
	int vertexSize;
	
	bool flags[6];//true if corresponding vertex attribute is enabled
	int offset[6];//number of bytes offset from where each attribute starts
	int size[6];//number of coordinates (for each attribute) per vertex

	GLuint createVBO(const void* data, int dataSize, GLenum target=GL_ARRAY_BUFFER, GLenum usage=GL_STATIC_DRAW);
public:
	
	VertexBuffer();
	void enableEntity(eflags entity, int size, int offset);
	void init(const void* vertices,GLuint * indices,int vertexSize, int numVertices, int numIndices, GLenum mode);
    void bind();	
	void render(bool bind_now = false);
	void renderInstances(int numInstances,GLint instanceIdLoc);
	void unbind();
	void deleteVBO();
	~VertexBuffer();

};

#endif
