#ifndef VECTOR_H
#define VECTOR_H

class vector3d{
public:
    float x,y,z;
	vector3d(float x=0, float y=0, float z=0);
	vector3d scale(float factor) const;
	vector3d negative() const;
	void setXYZ(float x, float y, float z);
	float absolute() const;
	vector3d getUnitVector() const;
	static float dotProduct(const vector3d & v1,const vector3d & v2);
	static vector3d crossProduct(const vector3d & v1,const vector3d & v2);
	vector3d operator - (const vector3d & v) const;
	vector3d operator + (const vector3d & v) const;
	bool operator == (const vector3d & v) const;
	vector3d parallelTo(const vector3d & ref) const;
	vector3d perpendicularTo(const vector3d & ref) const;
	float distanceTo(const vector3d & v) const;
	bool isNullVector() const;
	bool sameDirection(const vector3d v) const;
};

#endif
