#include<renderer.h>

Renderer::~Renderer()
    {
    //delete all shaders
    map<ShaderEnum, ProgramGLSL*>::iterator shaderIter;
    for( shaderIter = Shaders.begin(); shaderIter != Shaders.end(); ++shaderIter ) 
		delete shaderIter->second;
	
	//delete all rendertargets
    map<RenderTargetEnum, RenderTarget*>::iterator renderTargetIter;
    for( renderTargetIter = RenderTargets.begin(); renderTargetIter != RenderTargets.end(); ++renderTargetIter ) 
		delete renderTargetIter->second;
	
	//delete all textures
    map<TextureEnum, Texture*>::iterator textureIter;
    for( textureIter = Textures.begin(); textureIter != Textures.end(); ++textureIter ) 
		delete textureIter->second;
	
	//delete all vbos
    map<VBOEnum, VertexBuffer*>::iterator vertexIter;
    for (vertexIter = VertexBuffers.begin(); vertexIter != VertexBuffers.end(); ++vertexIter )
    	delete vertexIter->second;	
    }

bool Renderer::validateShaders()
    {
    map<ShaderEnum, ProgramGLSL*>::iterator shaderIter;
    for( shaderIter = Shaders.begin(); shaderIter != Shaders.end(); ++shaderIter ) 
	{
	cerr<<"compiling shader no. "<<shaderIter->first<<endl;
	shaderIter->second->link();
	if(!shaderIter->second->isValid())
	    {
	    cerr<<"Shader no. "<<shaderIter->first<<" failed!\n";
	    return true;
	    }
	}
    return false;
    }
