#include<SDL.h>

#include "sdlutil.h"
#include <SDL_image.h>
#include <iostream>

bool sdlInit()
    {

    /* Initialize */
    if (SDL_Init(SDL_INIT_VIDEO) < 0)
	{
	fprintf(stderr, "SDL_Init: %s\n", SDL_GetError());
	return true;
	}
    atexit(SDL_Quit);
    
    /* Start graphic system with OGL */
    SDL_GL_SetAttribute(SDL_GL_RED_SIZE, 5);
    SDL_GL_SetAttribute(SDL_GL_GREEN_SIZE, 5);
    SDL_GL_SetAttribute(SDL_GL_BLUE_SIZE, 5);
    SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE, 16);
    SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
    
    if (!SDL_SetVideoMode(sdlWidth, sdlHeight, 0, sdlFlags))
	{
	fprintf(stderr, "SDL_SetVideoMode: %s\n", SDL_GetError());
	return true;
	}

    return false;//the OS convention, 0 means ok else error. 
    }
    
int readImage(char * fname, unsigned char * & data, int & width, int & height){
	using namespace std;

	SDL_Surface *image;
	SDL_PixelFormat *fmt;
	
	image=IMG_Load(fname);
	if(!image) {
		cout<<"Image Load Error: "<<IMG_GetError()<<endl;
		return -1;
	}
	
	fmt	   = image->format;
	width  = image->w;
	height = image->h;
	int bpp = fmt->BytesPerPixel;
	
	size_t totalSize = width * height * 3;
	data   = new unsigned char[totalSize];
	
	unsigned char * rawData = static_cast<unsigned char *> (image->pixels);
	
	SDL_LockSurface(image);
	
	Uint32 col = 0 ;
	for (unsigned int i=0 ; i<totalSize ; i+= bpp){ 	
		memcpy ( &col , rawData + i , bpp ) ;
		SDL_GetRGB ( col , fmt , data+i, data+i+1, data+i+2) ;

		data[i] = rawData[i];
	}
	
	SDL_UnlockSurface(image);
	SDL_FreeSurface(image);
	
	return 0;
}
