#include <GL/glew.h>
#include <iostream>
#include "texBO.h"
using namespace std;

TextureBuffer::TextureBuffer(uint32_t elements, GLenum usage, const void* data)
	{
    glGenTextures( 1, &mTexture);
    glGenBuffers( 1, &mTextureBuffer);
	glBindBuffer( GL_TEXTURE_BUFFER_EXT, mTextureBuffer);
	glBufferData( GL_TEXTURE_BUFFER_EXT, 4 * elements * sizeof(float), data, usage);
    glBindTexture( GL_TEXTURE_BUFFER_EXT, mTexture);
    glTexBufferEXT( GL_TEXTURE_BUFFER_EXT, GL_RGBA32F_ARB, mTextureBuffer);
    mWidth=elements;
	}

TextureBuffer::~TextureBuffer()
	{
	glDeleteBuffers(1, &mTextureBuffer);
	glDeleteTextures(1, &mTexture);
	}

void* TextureBuffer::map()
	{
    glBindBuffer( GL_TEXTURE_BUFFER_EXT, mTextureBuffer);
	return glMapBuffer( GL_TEXTURE_BUFFER_EXT , GL_READ_ONLY);
	}

bool TextureBuffer::unmap()
	{
	bool retval=glUnmapBuffer( GL_TEXTURE_BUFFER_EXT );
	if(retval ==true)
		{
		glBindTexture( GL_TEXTURE_BUFFER_EXT, mTexture);
    	glTexBufferEXT( GL_TEXTURE_BUFFER_EXT, GL_RGBA32F_ARB, mTextureBuffer);
    	return true;
    	}
    else
    	{
    	return false;
    	}
	}
	
void TextureBuffer::bind()
	{
	glBindTexture( GL_TEXTURE_BUFFER_EXT, mTexture);
	}

void TextureBuffer::unbind()
	{
    glBindTexture( GL_TEXTURE_BUFFER_EXT, 0);
	}
