#include<cmath>
#include"tonemap.h"
using namespace std;
float knee (double x, double f)
{
    return float (std::log (x * f + 1) / f);
}


float findKneeF (float x, float y)
{
    float f0 = 0;
    float f1 = 1;

    while (knee (x, f1) > y)
    {
	f0 = f1;
	f1 = f1 * 2;
    }

    for (int i = 0; i < 30; ++i)
    {
	float f2 = (f0 + f1) / 2;
	float y2 = knee (x, f2);

	if (y2 < y)
	    f1 = f2;
	else
	    f0 = f2;
    }

    return (f0 + f1) / 2;
}


void setTonemapParams(ProgramGLSL* TonemapShader, float defog, float exposure, float kneeHigh, float kneeLow)
  {
//  cout<<"Setting tone map params..."<<endl;
  float kl=pow (2, kneeLow);
  float f= findKneeF (pow (2, kneeHigh) - kl,pow (2, 3.5) - kl);
  TonemapShader->assignUniform1f(TONEMAP_DEFOG, defog);
  TonemapShader->assignUniform1f(TONEMAP_EXPOSURE, exposure);
  TonemapShader->assignUniform1f(TONEMAP_KNEE_LOW, kl);
  TonemapShader->assignUniform1f(TONEMAP_KNEE_F, f);
  TonemapShader->assignUniform1i(TOMEMAP_TEXTURE,0);
//  cout<<"Done"<<endl;
  }


